import RPi.GPIO as GPIO
from time import sleep
import atexit
import psutil

GPIO.setmode(GPIO.BOARD)
#GPIO_RAM de 1 a 5 = 32, 33, 35, 38, 22 (board)
#GPIO_CPU de 1 a 5 = 11, 13, 15, 12, 16 (board)

GPIO.setup(32, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(33, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(35, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(38, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(22, GPIO.OUT, initial=GPIO.LOW)

GPIO.setup(11, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(13, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(15, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(12, GPIO.OUT, initial=GPIO.LOW)
GPIO.setup(16, GPIO.OUT, initial=GPIO.LOW)
try:
    totalRam = 1 #ram du rpi en go (1,2 ou 4 ou plus)
    cpuPercent = 0
    ramFree = 0
    while (True):
        cpuPercent = psutil.cpu_percent()
        ram = psutil.virtual_memory()
        ramFree = ram.available
        
        if cpuPercent >= 0 and cpuPercent <=20:
            cpuLed = 1
        elif cpuPercent >20 and cpuPercent <=40:
            cpuLed = 2
        elif cpuPercent >40 and cpuPercent <=60:
            cpuLed = 3
        elif cpuPercent >60 and cpuPercent <=80:
            cpuLed = 4
        elif cpuPercent >80 and cpuPercent <=100:
            cpuLed = 5
        
        if ramFree < 1024 * 1024 * 205 * totalRam:
            ramLed = 5
        elif ramFree >= 1024 * 1024 * 205 * totalRam and ramFree < 1024 * 1024 * 410 * totalRam:
            ramLed = 4
        elif ramFree >= 1024 * 1024 * 410 * totalRam and ramFree < 1024 * 1024 * 615 * totalRam:
            ramLed = 3
        elif ramFree >= 1024 * 1024 * 615 * totalRam and ramFree < 1024 * 1024 * 820 * totalRam:
            ramLed = 2
        elif ramFree >= 1024 * 1024 * 820 * totalRam and ramFree < 1024 * 1024 * 1025 * totalRam:
            ramLed = 1
            
        if ramLed == 1:
            GPIO.output(32, GPIO.HIGH)
        if cpuLed == 1:
            GPIO.output(11, GPIO.HIGH)
        
        if ramLed == 2:
            GPIO.output(33, GPIO.HIGH)
        if cpuLed == 2:
            GPIO.output(13, GPIO.HIGH)
        
        if ramLed == 3:
            GPIO.output(35, GPIO.HIGH)
        if cpuLed == 3:
            GPIO.output(15, GPIO.HIGH)
        
        if ramLed == 4:
            GPIO.output(38, GPIO.HIGH)
        if cpuLed == 4:
            GPIO.output(12, GPIO.HIGH)
        
        if ramLed == 5:
            GPIO.output(22, GPIO.HIGH)
        if cpuLed == 5:
            GPIO.output(16, GPIO.HIGH)
        
        sleep(1)
        
        if ramLed == 1:
            GPIO.output(32, GPIO.LOW)
        if cpuLed == 1:
            GPIO.output(11, GPIO.LOW)
        
        if ramLed == 2:
            GPIO.output(33, GPIO.LOW)
        if cpuLed == 2:
            GPIO.output(13, GPIO.LOW)

        if ramLed == 3:
            GPIO.output(35, GPIO.LOW)
        if cpuLed == 3:
            GPIO.output(15, GPIO.LOW)

        if ramLed == 4:
            GPIO.output(38, GPIO.LOW)
        if cpuLed == 4:
            GPIO.output(12, GPIO.LOW)

        if ramLed == 5:
            GPIO.output(22, GPIO.LOW)
        if cpuLed == 5:
            GPIO.output(16, GPIO.LOW)
        
except KeyboardInterrupt:
    print("key interrupt")
except:
    print("other exception")
finally:
    GPIO.cleanup()
    
def ExitFunction():
        GPIO.setmode(GPIO.BOARD)
        GPIO.setup(32, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(33, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(35, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(38, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(22, GPIO.OUT, initial=GPIO.LOW)

        GPIO.setup(11, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(13, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(15, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(12, GPIO.OUT, initial=GPIO.LOW)
        GPIO.setup(16, GPIO.OUT, initial=GPIO.LOW)
        GPIO.output(32, GPIO.LOW)
        GPIO.output(11, GPIO.LOW)
        GPIO.output(33, GPIO.LOW)
        GPIO.output(13, GPIO.LOW)
        GPIO.output(35, GPIO.LOW)
        GPIO.output(15, GPIO.LOW)
        GPIO.output(38, GPIO.LOW)
        GPIO.output(12, GPIO.LOW)
        GPIO.output(22, GPIO.LOW)
        GPIO.output(16, GPIO.LOW)
        print("ExitFunction: ok")
        
atexit.register(ExitFunction)
